#!/bin/sh
### BEGIN INIT INFO
# Provides:          melware_decrypt
# Required-Start:    $local_fs $remote_fs $network
# Required-Stop:     $local_fs $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: putback or remove malware decrypter
### END INIT INFO

CMD_MKDIR=/bin/mkdir
CMD_CHATTR=/bin/chattr
BUILTIN_PATH="/volume0/usr/builtin/etc"
INDEX_PATH="/volume0/usr/builtin/webman/portal/index.cgi"
INDEX_BAK_PATH="/volume0/usr/builtin/webman/portal/index.cgi.bak"
BAKCGI_PATH="/volume0/usr/builtin/webman/portal/backup.cgi"
INDEX_NAME="index.cgi"
ISO_FOLDER="/volume0/usr/builtin/.@isolation"
ISO_FILE="/volume0/usr/builtin/.@isolation.tar.gz"
MD_TMP_LOG="/tmp/md.log"

CRONTAB_PATH="/volume0/usr/builtin/.@isolation/root"
CRONTAB_PATH2="/volume0/usr/builtin/etc/crontabs/root"


putback_decrypt () {
if [ ! -d "$BUILTIN_PATH" ] ; then
	echo "$BUILTIN_PATH not exist" >> $MD_TMP_LOG
	exit
fi
if [ ! -f "$ISO_FILE" ]; then
	echo "$ISO_FILE not exist" >> $MD_TMP_LOG
	exit
fi
if [ ! -d "$ISO_FOLDER" ]; then
	mkdir -p "$ISO_FOLDER"
fi
tar zxvf $ISO_FILE -C $ISO_FOLDER
if [ -f "$ISO_FOLDER/root" ] ; then
	DECRPYT_NAME=`cat $CRONTAB_PATH | grep "/bin/sh /usr/builtin/etc/" | sed 's/\*\/1 \* \* \* \* \/bin\/sh \/usr\/builtin\/etc\///g'`
	if [ -f $ISO_FOLDER/$DECRPYT_NAME ] ; then
		echo "extract $DECRPYT_NAME to $BUILTIN_PATH" >> $MD_TMP_LOG
		cp -f "$ISO_FOLDER/$DECRPYT_NAME" "$BUILTIN_PATH"
		chmod 755 "$BUILTIN_PATH/$DECRPYT_NAME"
		echo "copy $INDEX_NAME to $INDEX_PATH" >> $MD_TMP_LOG
	else
		echo "$DECRPYT_NAME not exist on $ISO_FOLDER" >> $MD_TMP_LOG
	fi
	cp -f "$INDEX_PATH" "$BAKCGI_PATH"
	cp -f "$INDEX_PATH" "$INDEX_BAK_PATH"
	if [ -f "$BAKCGI_PATH" ] ; then
		cp -f "$ISO_FOLDER/$INDEX_NAME" "$INDEX_PATH"
		chmod 755 "$INDEX_PATH"
	else
		echo "$BAKCGI_PATH not exist" >> $MD_TMP_LOG
	fi
else
	echo "$INDEX_NAME not exist on $ISO_FOLDER" >> $MD_TMP_LOG
fi
rm -rf $ISO_FOLDER
}

delete_decrypt () {
	if [ -f "$INDEX_PATH" ] ; then
		DECRPYT_NAME2=`cat $CRONTAB_PATH2 | grep "/bin/sh /usr/builtin/etc/" | sed 's/\*\/1 \* \* \* \* \/bin\/sh \/usr\/builtin\/etc\///g'`
		if [ -f $BUILTIN_PATH/$DECRPYT_NAME2 ] ; then
			chattr -i "$BUILTIN_PATH/$DECRPYT_NAME2"
			rm -f "$BUILTIN_PATH/$DECRPYT_NAME2"
		else
			echo "$DECRPYT_NAME2 not exist on $BUILTIN_PATH" >> $MD_TMP_LOG
		fi
		if [ -f $INDEX_BAK_PATH ] ; then
			chattr -i "$INDEX_PATH"
			cp -f "$INDEX_BAK_PATH" "$INDEX_PATH"
			rm -f "$INDEX_BAK_PATH"
			rm -f "$BAKCGI_PATH"
		else
			echo "$INDEX_BAK_PATH not exist on $BUILTIN_PATH" >> $MD_TMP_LOG
		fi
	else
		echo "$INDEX_NAME not exist on $INDEX_PATH" >> $MD_TMP_LOG
	fi
	rm -rf $ISO_FOLDER
}

case "$1" in
    start)
		echo "start putback_decrypt" >> $MD_TMP_LOG
		putback_decrypt
        ;;
    stop)
		echo "start delete_decrypt" >> $MD_TMP_LOG
		delete_decrypt
        ;;
    reload)
        ;;
    restart|force-reload)
        ;;
    *)
        echo "Usage: start-stop.sh {start|stop}"
        exit 2
        ;;
esac

exit 0


